SPOJ 375 树链剖分

点击打开链接

题意:给个树和树上的权值,两个操作,Q u v,问u到v的边上的最大权值,C u v,将第u条边的权值改为v

思路:今天学了学树链剖分,这题是个检验模版的题目,理论我是解释不清楚的,自己在九野聚聚那学来的一份模版

#include <vector>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int inf=0x3f3f3f3f;
const ll INF=0x3f3f3f3f3f3f3f3fll;
const int maxn=10010;
int fa[maxn],siz[maxn],son[maxn],w[maxn],p[maxn],dep[maxn],fp[maxn];
//fa为父节点,siz为子节点中siz最大的,dep为深度,son为重儿子,w表示在线段树中的位置
int max1[maxn<<2];
int tree_id,n;
vector<int>G[maxn];
void dfs1(int u,int ff,int deep){
    son[u]=0;fa[u]=ff;siz[u]=1;dep[u]=deep;
    for(unsigned int i=0;i<G[u].size();i++){
        int v=G[u][i];
        if(v==ff) continue;
        dfs1(v,u,deep+1);
        siz[u]+=siz[v];
        if(siz[v]>siz[son[u]]) son[u]=v;
    }
}
void dfs2(int u,int ff){
    w[u]=++tree_id;p[u]=ff;
    if(son[u]) dfs2(son[u],ff);
    else return ;
    for(unsigned int i=0;i<G[u].size();i++){
        int v=G[u][i];
        if(v!=fa[u]&&v!=son[u]) dfs2(v,v);
    }
}
void update(int pos,int val,int le,int ri,int node){
    if(le==ri){
        max1[node]=val;
        return ;
    }
    int t=(le+ri)>>1;
    if(pos<=t) update(pos,val,le,t,node<<1);
    else update(pos,val,t+1,ri,node<<1|1);
    max1[node]=max(max1[node<<1],max1[node<<1|1]);
}
int query(int l,int r,int le,int ri,int node){
    if(l<=le&&ri<=r) return max1[node];
    int t=(le+ri)>>1,ans=0;
    if(l<=t) ans=max(ans,query(l,r,le,t,node<<1));
    if(r>t) ans=max(ans,query(l,r,t+1,ri,node<<1|1));
    return ans;
}
int getans(int u,int v){
    int f1=p[u],f2=p[v],tmp=0;
    while(f1!=f2){
        if(dep[f1]<dep[f2]){
            swap(f1,f2);
            swap(u,v);
        }
        tmp=max(tmp,query(w[f1],w[u],1,n,1));
        u=fa[f1];f1=p[u];
    }
    if(u==v) return tmp;
    if(dep[u]>dep[v]) swap(u,v);
    return max(tmp,query(w[son[u]],w[v],1,n,1));
}
int U[maxn],V[maxn],C[maxn];
int main(){
    int T,u,v;
    char str[10];
    scanf("%d",&T);
    while(T--){
        scanf("%d",&n);
        for(int i=0;i<maxn;i++) G[i].clear();
        memset(son,0,sizeof(son));tree_id=0;
        for(int i=0;i<n-1;i++){
            scanf("%d%d%d",&U[i],&V[i],&C[i]);
            G[U[i]].push_back(V[i]);
            G[V[i]].push_back(U[i]);
        }
        dfs1(1,1,0);
        dfs2(1,1);
        memset(max1,0,sizeof(max1));
        for(int i=0;i<n-1;i++){
            if(dep[U[i]]>dep[V[i]]) swap(U[i],V[i]);
            update(w[V[i]],C[i],1,n,1);
        }
        while(1){
            scanf("%s",str);
            if(str[0]=='D') break;
            scanf("%d%d",&u,&v);
            if(str[0]=='C') update(w[V[u-1]],v,1,n,1);
            else printf("%d\n",getans(u,v));
        }
    }
    return 0;
}
时间: 2024-11-05 15:58:41

SPOJ 375 树链剖分的相关文章

SPOJ QTREE 树链剖分

375. Query on a tree Problem code: QTREE You are given a tree (an acyclic undirected connected graph) with N nodes, and edges numbered 1, 2, 3...N-1. We will ask you to perfrom some instructions of the following form: CHANGE i ti : change the cost of

【学术篇】SPOJ QTREE 树链剖分

发现链剖这东西好久不写想一遍写对是有难度的.. 果然是熟能生巧吧.. WC的dalao们都回来了 然后就用WC的毒瘤题荼毒了我们一波, 本来想打个T1 44分暴力 然后好像是特判写挂了还是怎么的就只能得28pts.. 重新见到这些失踪的dalao灰常开心, 于是想让自己心情稍微差一点, 就想着把自己昨天写WA的QTREE重构一遍吧.. 于是重构的sb链剖果然挂掉了... 出现了各种各样的漏洞... 忘记各种各样的句子, 然而退化成了暴力小数据也随便过看不出来啊~~~ 但是还是在1h之内调对了_(

SPOJ 375 QTREE系列-Query on a tree (树链剖分)

题目地址:SPOJ 375 树链剖分第一发! 果然是个貌似很高级的数据结构,其实就是把树的边从树形结构转化成了线性结构,从而可以用线段树或树状数组之类的数据结构进行快速维护.从而将时间缩到n*log(2*n). 这题用的线段树维护的. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm> #incl

SPOJ - QTREE 375 Query on a tree 树链剖分+线段树

操作1:修改第k条边权. 操作2:询问两点间最大边权. 树链剖分,然后线段树维护最大值 #include<cstdio> #include<cstring> #include<cmath> #include<iostream> #include<algorithm> #include<set> #include<map> #include<queue> #include<vector> #inclu

spoj 375 AND bzoj 1036 树链剖分

树链剖分的入门题目,自己写了下感觉还是挺好写的,不过真的有点长... spoj 375 边有权值: 1 #include <iostream> 2 #include <cstring> 3 #include <cstdio> 4 using namespace std; 5 6 const int INF = -999999999; 7 const int N = 10001; 8 int head[N]; 9 int sz[N]; 10 int depth[N]; 1

【树链剖分模板】【SPOJ 375】 Query on a tree

375. Query on a tree Problem code: QTREE You are given a tree (an acyclic undirected connected graph) with N nodes, and edges numbered 1, 2, 3...N-1. We will ask you to perfrom some instructions of the following form: CHANGE i ti : change the cost of

SPOJ 375 QTREE - Query on a tree(树链剖分)

题目链接:http://www.spoj.com/problems/QTREE/en/ 题意:  一棵树 n 个节点,每条边上有权值,同时有两个操作: (1)更改操作:CHANGE i ti(把第 i 条边上的权值改为 ti). (2)查询操作:QUERY a b(查询 a 到 b 的路径上权值最大的边的权值). 思路(树链剖分): 看到这种区间查询的题想要用数据结构优化,提高时间效率一般会想到线段树.可是这次操作的对象并不是一组序列, 无法直接使用线段树.这时,我们可以做些转化:对树作树链剖分

spoj 375 Query on a tree (树链剖分)

Query on a tree You are given a tree (an acyclic undirected connected graph) with N nodes, and edges numbered 1, 2, 3...N-1. We will ask you to perfrom some instructions of the following form: CHANGE i ti : change the cost of the i-th edge to ti or Q

spoj 375 QTREE - Query on a tree 树链剖分

题目链接 给一棵树, 每条边有权值, 两种操作, 一种是将一条边的权值改变, 一种是询问u到v路径上最大的边的权值. 树链剖分模板. #include <iostream> #include <vector> #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <map> #include <set&g